## arpack 3.3.0

=== debian/changelog ===
arpack (3.3.0-1build2) xenial; urgency=medium

  * No-change rebuild for openmpi on s390x.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 06 Feb 2016 19:26:54 +0000

arpack (3.3.0-1build1) xenial; urgency=medium

  * No-change rebuild for openmpi transition.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Feb 2016 11:21:57 +0000

arpack (3.3.0-1) unstable; urgency=medium

  * New upstream release
  * Update of the homepage (moved to github)
  * libparpack links against libarpack (instead of static build)
  * Update the symbol files. No need to change of SONAME:
    - About the parpack change: https://github.com/opencollab/arpack-ng/pull/21
    - Transfer the call to the library:
      https://github.com/opencollab/arpack-ng/pull/19
  * Standards-Version updated to version 3.9.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 12 Oct 2015 09:33:05 +0200

arpack (3.1.5-3) unstable; urgency=medium

  * update the symbol list for mips64 & mips64el (Closes: #746277)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 30 Apr 2014 18:26:52 +0200
