=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh  $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure --  --enable-mpi

override_dh_strip:
	dh_strip -Xlibparpack2 --dbg-package=libarpack2-dbg
	dh_strip --dbg-package=libparpack2-dbg

.PHONY: override_dh_strip
