=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/arpack-ng-$1.tar.gz/" \
   https://github.com/opencollab/arpack-ng/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz
