## arpack 3.4.0

=== debian/changelog ===
arpack (3.4.0-1) unstable; urgency=medium

  * New upstream release
  * mpi_fortran_unweighted_ &  mpi_fortran_weights_empty_ added as new
    symbols
  * Breaks: octave3.2 => removed as octave 3.2 no longer exists in Debian
  * Standards-Version updated to 3.9.8

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jul 2016 21:54:37 +0200
