=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Sylvestre Ledru <sylvestre@debian.org>
 Build-Depends: quilt, debhelper (>= 7.0.50), gfortran,
  libblas-dev, liblapack-dev, mpi-default-dev (>= 0.3), dh-autoreconf
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/arpack/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/arpack/
 Homepage: https://github.com/opencollab/arpack-ng
@@ -18,7 +18,6 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: arpack2
 Conflicts: arpack2
-Breaks: octave3.2
 Description: Fortran77 subroutines to solve large scale eigenvalue problems
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
