=== debian/changelog ===
arpack (3.5.0+real-2) unstable; urgency=medium

  * Team upload.
  * Moved packaging from SVN to Git
  * Standards-Version: 4.1.3

 -- Andreas Tille <tille@debian.org>  Wed, 24 Jan 2018 09:06:55 +0100

arpack (3.5.0+real-1) unstable; urgency=medium

  * Team upload.
  * Really upload 3.5.0 upstream release. (Closes: #875697)
  * Fix debian/watch file (and upgrade to format version 4).
  * Update symbols file for libparpack2.
  * Bump to debhelper compat level 10.
  * Mark shared and development library packages as Multi-Arch: same.
  * Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS).
  * Ship arpack.pc in libarpack2-dev.
  * Use canonical URLs for Vcs-* fields.
  * Install doc using dh_installdocs (instead of dh_install).
  * Migrate to -dbgsym debug packages.
  * Bump priority of -dev packages to optional, per policy 4.0.1.
  * Add BLAS/LAPACK virtual -dev packages as alternatives in dependency list of
    ARPACK -dev packages (Closes: #757189)
  * Bump Standards-Version to 4.1.0.
  * Remove obsolete README.source.
  * Remove obsolete source lintian override.
  * Remove obsolete Conflicts+Replaces on arpack2{,-dev}.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 14 Sep 2017 12:16:59 +0200

arpack (3.5.0-1) unstable; urgency=medium

  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 18 Jun 2017 19:24:59 +0200

arpack (3.5.0-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 16 May 2017 13:37:16 +0200

arpack (3.4.0-2) unstable; urgency=medium

  * Remove MIA maintainers (Closes: #835005)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 21 Aug 2016 16:08:00 +0200
