=== debian/control ===
--- 
+++ 
@@ -1,23 +1,24 @@
 Source: arpack
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Sylvestre Ledru <sylvestre@debian.org>
 Section: math
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Christophe Prud'homme <prudhomm@debian.org>,
- "Adam C. Powell, IV" <hazelsct@debian.org>,
- Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: quilt, debhelper (>= 7.0.50), gfortran,
- libblas-dev, liblapack-dev, mpi-default-dev (>= 0.3), dh-autoreconf
-Standards-Version: 3.9.8
-Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/arpack/trunk/
-Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/arpack/
+Build-Depends: debhelper (>= 10),
+               gfortran,
+               libblas-dev,
+               liblapack-dev,
+               mpi-default-dev
+Standards-Version: 4.1.3
+Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
+Vcs-Git: https://salsa.debian.org/science-team/arpack.git
 Homepage: https://github.com/opencollab/arpack-ng
 
 Package: libarpack2
+Architecture: any
+Multi-Arch: same
 Section: libs
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: arpack2
-Conflicts: arpack2
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Description: Fortran77 subroutines to solve large scale eigenvalue problems
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
@@ -46,13 +47,13 @@
  This package contains the shared library.
 
 Package: libarpack2-dev
+Architecture: any
+Multi-Arch: same
 Section: libdevel
-Priority: extra
-Architecture: any
-Depends:  libarpack2 (= ${binary:Version}), libblas-dev, liblapack-dev,
- ${misc:Depends}
-Replaces: arpack2-dev
-Conflicts: arpack2-dev
+Depends: libarpack2 (= ${binary:Version}),
+         libblas-dev | libblas.so,
+         liblapack-dev | liblapack.so,
+         ${misc:Depends}
 Description: Fortran77 subroutines to solve large scale eigenvalue problems (development)
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
@@ -67,30 +68,13 @@
  This package contains the static libraries and the documentation for
  development with libarpack (including examples).
 
-Package: libarpack2-dbg
-Section: debug
+Package: libparpack2
 Architecture: any
-Priority: extra
-Depends:  libarpack2 (= ${binary:Version}), ${misc:Depends}
-Description: Fortran77 subroutines to solve large scale eigenvalue problems (debug)
- ARPACK software is capable of solving large scale symmetric,
- nonsymmetric, and generalized eigenproblems from significant
- application areas. The software is designed to compute a few (k)
- eigenvalues with user specified features such as those of largest
- real part or largest magnitude. Storage requirements are on the order
- of n*k locations. No auxiliary storage is required. A set of Schur
- basis vectors for the desired k-dimensional eigen-space is computed
- which is numerically orthogonal to working precision. Numerically
- accurate eigenvectors are available on request.
- .
- This package contains the debugging symbols for libarpack and libparpack.
-
-
-Package: libparpack2
+Multi-Arch: same
 Section: libs
-Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Replaces: libarpack2
-Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Parallel subroutines to solve large scale eigenvalue problems
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
@@ -121,10 +105,14 @@
  This package contains the shared library.
 
 Package: libparpack2-dev
+Architecture: any
+Multi-Arch: same
 Section: libdevel
-Priority: extra
-Architecture: any
-Depends:  libparpack2 (= ${binary:Version}), libblas-dev, liblapack-dev, mpi-default-dev, ${misc:Depends}
+Depends: libparpack2 (= ${binary:Version}),
+         libblas-dev | libblas.so,
+         liblapack-dev | liblapack.so,
+         mpi-default-dev,
+         ${misc:Depends}
 Replaces: libarpack2-dev
 Description: Parallel subroutines to solve large scale eigenvalue problems (development)
  ARPACK software is capable of solving large scale symmetric,
@@ -139,22 +127,3 @@
  .
  This package contains the static libraries and the documentation for
  development with libparpack (including examples).
-
-Package: libparpack2-dbg
-Section: debug
-Architecture: any
-Priority: extra
-Depends:  libparpack2 (= ${binary:Version}), ${misc:Depends}
-Replaces: libarpack2-dbg
-Description: Parallel subroutines to solve large scale eigenvalue problems (debug)
- ARPACK software is capable of solving large scale symmetric,
- nonsymmetric, and generalized eigenproblems from significant
- application areas. The software is designed to compute a few (k)
- eigenvalues with user specified features such as those of largest
- real part or largest magnitude. Storage requirements are on the order
- of n*k locations. No auxiliary storage is required. A set of Schur
- basis vectors for the desired k-dimensional eigen-space is computed
- which is numerically orthogonal to working precision. Numerically
- accurate eigenvectors are available on request.
- .
- This package contains the debugging symbols for libparpack.
