=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	# Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS)
	dh_auto_configure --  --enable-mpi --with-blas=blas

override_dh_strip:
	dh_strip --dbgsym-migration='libarpack2-dbg (<< 3.5.0+real-1~), libparpack2-dbg (<< 3.5.0+real-1~)'
