## arpack 3.6.2

=== debian/changelog ===
arpack (3.6.2-1) unstable; urgency=medium

  * New upstream release
    Should fix FTBFS on armel, mips64el, ppc64el
    (Closes: #904091)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 22 Jul 2018 17:41:40 +0200

arpack (3.6.1-1) unstable; urgency=medium

  * New upstream release.
    Hopefully fix a regression on i386 and other archs

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 09 Jun 2018 18:31:25 +0200

arpack (3.6.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.4
  * Update of the copyright file

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 05 Jun 2018 21:01:11 +0200
