## arpack 3.6.3

=== debian/changelog ===
arpack (3.6.3-1) unstable; urgency=medium

  * New upstream release
    fix a regression with dnaupd (Closes: #908648)
  * Standards-Version: 4.2.1

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 19 Sep 2018 10:05:11 +0200
