=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libblas-dev,
                liblapack-dev,
                mpi-default-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
 Vcs-Git: https://salsa.debian.org/science-team/arpack.git
 Homepage: https://github.com/opencollab/arpack-ng
