=== debian/changelog ===
arpack (3.7.0-3) unstable; urgency=medium

  * Enable C/C++ bindings

 -- Julien Schueller <schueller@phimeca.com>  Thu, 31 Oct 2019 17:29:41 +0100

arpack (3.7.0-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on single core builders
    - New patch 0001-Run-MPI-tests-on-a-single-cpu.patch
    Thanks to Santiago Vila (Closes: #926935)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 25 Apr 2019 00:34:46 +0200

arpack (3.7.0-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 12 Jan 2019 16:29:41 +0100
