=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
                gfortran,
                libblas-dev,
                liblapack-dev,
-               mpi-default-dev
+               mpi-default-dev,
+               libeigen3-dev
 Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
 Vcs-Git: https://salsa.debian.org/science-team/arpack.git
