=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,11 @@
 
 override_dh_auto_configure:
 	# Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS)
-	dh_auto_configure --  --enable-mpi --with-blas=blas
+	dh_auto_configure --  --enable-mpi --with-blas=blas --enable-icb
+
+override_dh_auto_test:
+# Disable fakeroot because of https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
+	env -u LD_PRELOAD make check
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='libarpack2-dbg (<< 3.5.0+real-1~), libparpack2-dbg (<< 3.5.0+real-1~)'
